var humanURL =
{
  saveRaw: '',
  saveRes: '',
  httpProtocol: true,
  ftpProtocol: true,
  fileProtocol: true,

  hmuObserver: {
    observe: function (subject, topic, state) 
    {
      if (topic == 'humanurl-Update-Settings')
      {
        try {
          if(HUMANURL_PREFS.prefHasUserValue('http')) {
            humanURL.httpProtocol = HUMANURL_PREFS.getBoolPref('http');
          }
          if(HUMANURL_PREFS.prefHasUserValue('https')) {
            humanURL.httpsProtocol = HUMANURL_PREFS.getBoolPref('https');
          }
          if(HUMANURL_PREFS.prefHasUserValue('ftp')) {
            humanURL.ftpProtocol = HUMANURL_PREFS.getBoolPref('ftp');
          }
          if(HUMANURL_PREFS.prefHasUserValue('file')) {
            humanURL.fileProtocol = HUMANURL_PREFS.getBoolPref('file');
          }
        }
        catch(err) {}

      }
    }
  },

  init: function() {
    this.localizingDescription();
    try {
      var prefs = Components.classes['@mozilla.org/preferences-service;1'].
                    getService(Components.interfaces.nsIPrefBranch);

      if (prefs.getPrefType('network.standard-url.escape-utf8') == prefs.PREF_BOOL){
        if(!prefs.getBoolPref('network.standard-url.escape-utf8'))
          prefs.setBoolPref('network.standard-url.escape-utf8',true);
      }
      if (prefs.getPrefType('network.standard-url.encode-utf8') == prefs.PREF_BOOL){
        if(prefs.getBoolPref('network.standard-url.encode-utf8'))
          prefs.setBoolPref('network.standard-url.encode-utf8',false);
      }
    }
    catch(err){}

    try {
      if(!HUMANURL_PREFS.prefHasUserValue('http')) {
        HUMANURL_PREFS.setBoolPref('http', this.httpProtocol);
      }
      if(!HUMANURL_PREFS.prefHasUserValue('https')) {
        HUMANURL_PREFS.setBoolPref('http', this.httpsProtocol);
      }
      if(!HUMANURL_PREFS.prefHasUserValue('ftp')) {
        HUMANURL_PREFS.setBoolPref('ftp', this.ftpProtocol);
      }
      if(!HUMANURL_PREFS.prefHasUserValue('file')) {
        HUMANURL_PREFS.setBoolPref('file', this.fileProtocol);
      }
    }
    catch(err) {}

    window.document.getElementById('urlbar').watch('value', this.changeURL);

  },

  localizingDescription: function() {

    HMU_BUNDLE = document.getElementById('humanurl-string-bundle');
    
    //~ localizing initial description here :o)
    //~ "Goofy-method", thanks Luana aka MatrixIsAllOver (extenzilla.it)
    
    var hmuL18Prefs = Components.classes['@mozilla.org/preferences-service;1']
                                .getService(Components.interfaces.nsIPrefService)
                                .getBranch('extensions.{0bb97196-c445-47bb-9119-f6453518cc25}.');
    var hmuDescription = Components.classes['@mozilla.org/supports-string;1']
                                .createInstance(Components.interfaces.nsISupportsString);

    hmuDescription.data = HMU_BUNDLE.getString('initialDescription');
    hmuL18Prefs.setComplexValue('description', Components.interfaces.nsISupportsString, hmuDescription);

    hmuDescription.data = HMU_BUNDLE.getString('initialCreator');
    hmuL18Prefs.setComplexValue('creator', Components.interfaces.nsISupportsString, hmuDescription);

  },
  
  getContent: function() {
    var cont = getBrowser().contentWindow;
    try {
      cont = new XPCNativeWrapper(cont).wrappedJSObject;
    } catch(e) { return 0}
    if (!cont) cont = getBrowser().contentWindow;
    return cont;
  },
  
  decodeStr: function(url, charset) {
    try {
    var utf8service =  Components.classes['@mozilla.org/intl/utf8converterservice;1'].
          createInstance(Components.interfaces.nsIUTF8ConverterService);
    } 
    catch(err){
      return url;
    }

    var okURIchars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789_-';

    var str = '';
    var backup=url;
    url=unescape(url);
    for(i=0;i<url.length;i++) {
      if (okURIchars.indexOf(url.charAt(i))==-1 && url.charCodeAt(i)<256) {
        try{         

          if(charset == 'UTF-8' &&  url.charCodeAt(i)>128 ){
                str += utf8service.convertStringToUTF8(url.slice(i,i+2), charset,'false');
                i++;
          }
          else str += utf8service.convertStringToUTF8(url[i], charset,'false');

        }
        catch(err){
          return backup;
        }
      }
      else
        str += url[i]; 
    }
    return str;
  },

  changeURL: function(id, oldval, newval) {
    if(newval==humanURL.saveRaw)
      return humanURL.saveRes;
    if(newval==humanURL.saveRes)
      return humanURL.saveRes;

    if(humanURL.httpProtocol && newval.indexOf('http://')==0 || humanURL.httpsProtocol && newval.indexOf('https://')==0 || humanURL.ftpProtocol && newval.indexOf('ftp://')==0) {

      var doc = humanURL.getContent().document;
      if(!doc) 
        return newval;      

      if((doc.location.href == newval || /*???*/(newval.indexOf('ftp://')==0 && doc.location.href == (newval+'/'))/*stupid bug*/ ) 
           && doc.characterSet) {
        var res = humanURL.decodeStr(newval, doc.characterSet);
        humanURL.saveRaw = newval;
        humanURL.saveRes = res;
        return res;
      }
      else 
        return newval;
    }
      
    if(humanURL.fileProtocol && newval.indexOf('file://')==0) {
     var res = '';

    try {
       var ioServ = Components.classes['@mozilla.org/network/io-service;1']
                       .createInstance(Components.interfaces.nsIIOService);
       var fileURL = ioServ.newURI(newval, "utf-8", null)
                .QueryInterface(Components.interfaces.nsIFileURL);
       var res = fileURL.file.path;
     }
     catch(err) {return newval}
     


     if(res=='' || res=='undefined' || !fileURL.file.isFile()) {
       return newval;
     }

     res = 'file://' + (res[0]=='/'?res:'/'+res).replace(/\\/g,'/');
     humanURL.saveRaw = newval;
     humanURL.saveRes = res;
     /*!not work! try {
        var globHist = Components.classes['@mozilla.org/browser/global-history;2']
                       .createInstance(Components.interfaces.nsIGlobalHistory2);
        globHist.setPageTitle ( newval , res );
     } catch(err){alert();};*/
     return res;
    }
    else
      return newval;
  }

};

HUMANURL_OBSERVER.addObserver(humanURL.hmuObserver, 'humanurl-Update-Settings', false);
HUMANURL_OBSERVER.notifyObservers(humanURL.hmuObserver, 'humanurl-Update-Settings', false);

window.addEventListener('load', function() { humanURL.init(); }, false);

function hmuSettings() {

   var params = { ok:false, url:"" };
   var win = window.openDialog("chrome://humanurl/content/options.xul",
     "humanurl-opt-dialog","chrome,centerscreen,modal", params);  

}
